/*	1993,1994,1995,1998	H.Ogasawara (COR.)	*/
/*	1998				S.Honma (Rick)		*/

#include	<stdio.h>
#include	<string.h>
#include	"ai.h"

#define		ENCODING	"Base64"

#define		IOBUF		256
#define		STRBUF		256


static char	file_outname[STRBUF],
			base[92],
			exfile[STRBUF];

static unsigned char	ibuf[IOBUF];


static int
attach_check( ptr )
unsigned char	*ptr;
{
	unsigned char	buf[STRBUF];
	ptr= get_word( buf, ptr );
	if( !p_strcmpi( buf, "attachment" ) ){
		if( *ptr == ';' )
			ptr= get_word( buf, ptr+1 );
		if( !p_strcmpi( buf, "filename" ) ){
				if( *ptr == '=' )
					get_tkn( file_outname, ptr+1 );
					return TRUE;
		}
	}
	return FALSE;
}

static int
text_decode( fp, boundary )
FILE	*fp;
char	*boundary;
{
	char	fullname[STRBUF], *ptr;
	int	ret= FALSE;
	FILE	*fo;

	if( !*file_outname )	return FALSE;
	ptr= p_strcpy( fullname, base );
	p_strcpy( ptr, file_outname );
	if( fo= fopen( fullname, "wt" ) ){
		while( fgets( ibuf, IOBUF, fp ) ){
			if( !p_strmatch( ibuf, boundary ) ){
				ret= TRUE;
				break;
			}
			fputs( ibuf, fo );
		}
		fclose( fo );
	}
	return ret;
}

static void
bin_decode( fp )
FILE	*fp;
{
	unsigned char	obuf[IOBUF];
	unsigned char	fullname[STRBUF], *ptr;
	FILE	*fo;

	if( !*file_outname )	return;
	ptr= p_strcpy( fullname, base );
	p_strcpy( ptr, file_outname );
	if( fo= fopen( fullname, "wb" ) ){
		for(; fgets( ibuf, IOBUF, fp ) ;){
			if( *ibuf == '\n' )	break;
			ptr= decbenc( obuf, ibuf );
			fwrite( obuf, sizeof( char ), ptr - obuf, fo );
		}
		fclose( fo );
	}
}

static int
content_decode( fp )
FILE	*fp;
{
	char	encoding_name[60];
	int	ret= 0;

	*encoding_name= '\0';
	*file_outname= '\0';

	for(; fgets( ibuf, IOBUF, fp ) ;){
		if( *ibuf == '\n' )	break;
		if( !p_strmatch( ibuf, "Content-Transfer-Encoding: " ) ){
			get_word( encoding_name, ibuf+27 );
			if( !p_strcmpi( encoding_name, ENCODING ) ){
				ret++;
			}
		}else if( !p_strmatch( ibuf, "Content-Disposition: " ) ){
			if( attach_check( ibuf+21 ) ){
				ret++;
			}
		}
	}
	return ret;
}

static void
MimeDec( fp )
FILE	*fp;
{
	char	file_boundary[STRBUF];
	int	BoundaryFlag= 0, q= 0;

	p_strcpy( file_boundary, "--" );

	/* wb_΂B̉ߒBOUNDARYE */
	while( fgets( ibuf, IOBUF, fp ) ){
		if( *ibuf == '\n' ){
			break;					/* ŝ݂mimewb_Gh */
		}else if( !p_strmatch( ibuf, "Content-Type: " ) ){
			char	*tmp;
			if( tmp= strstr( ibuf, "boundary=" ) ){	/* boundary o */
				tmp+= 9;
				if( *tmp == '\"' ){	/* p̒擾 */
					char	*ptr= file_boundary + 2;
					for( ++tmp; *tmp && *tmp != '\"'; *ptr++= *tmp++ );
					*ptr= '\0';
				}else {
					p_strcpy( file_boundary + 2, tmp );
				}
				BoundaryFlag= 1;
			}
			break;
		}
	}
	if( !BoundaryFlag )	return;

	while( q || fgets( ibuf, IOBUF, fp ) ){
		q= 0;
		if( !p_strmatch( ibuf, file_boundary ) ){
			BoundaryFlag= content_decode( fp );
			if( !*exfile || !p_strcmpi( file_outname, exfile ) ){
				if( BoundaryFlag == 2 ){
					bin_decode( fp );
				}else if( BoundaryFlag ){
					q= text_decode( fp, file_boundary );
				}
			}
		}
	}

	return;
}

void
main( argc, argv )
int	argc;
unsigned char	**argv;
{
	FILE	*fp;

	base[0]= '\0';
	exfile[0]= '\0';

	while( --argc ){
		if( **++argv == '-' ){
			if( (*argv)[1] == 'b' ){
				char	*ptr;
				ptr= p_strcpy( base, *argv + 2 );
				*ptr= '\\';
				*ptr= '\0';
			}else if( (*argv)[1] == 'x' ){
				p_strcpy( exfile, *argv + 2 );
			}
		}else {
			if( fp= fopen( *argv, "rt" ) ){
				MimeDec( fp );
				fclose( fp );
			}else {
				fputs( "open error\n", stderr );
			}
		}
	}
}
